# Create cross-sheet references

Adds a cross-sheet reference between two sheets and defines the data range for formulas. Each distinct data range requires a new cross-sheet reference.

Endpoint: POST /sheets/{sheetId}/crosssheetreferences
Version: 2.0.0
Security: APIToken, OAuth2

## Path parameters:

  - `sheetId` (number, required)
    ID of the sheet being accessed.

## Header parameters:

  - `Authorization` (string)
    API Access Token used to authenticate requests to Smartsheet APIs.

  - `smartsheet-integration-source` (string)
    Uses the following metadata to distinguish between human-initiated API requests and third-party service-initiated calls by AI Connectors or ITSM:

- Integration source type
- Organization name
- Integration source name 

Format:


TYPE,OrgName,SourceName


Examples: 

AI,SampleOrg,My-AI-Connector-v2

SCRIPT,SampleOrg2,Accounting-updater-script

APPLICATION,SampleOrg3,SheetUpdater
    Example: "AI,SampleOrg,My-AI-Connector-v2"

  - `Content-Type` (string)
    Required for POST and PUT requests. Defines the structure for the request body.

## Response 200 fields (application/json):

  - `version` (number,null)
    New version of the sheet. Applicable only for operations which update sheet data.

  - `failedItems` (array,null)
    Array of BulkItemFailure objects which represents the items that failed to be added or updated. See [Bulk operations > Partial success](/api/smartsheet/guides/advanced-topics/scalability-options) for more information. Applicable only for bulk operations that support partial success.

  - `failedItems.rowId` (number,null)
    The ID of the row that failed. Applicable only to bulk row operations.

  - `failedItems.error` (object)
    The error caused by the failed item.

  - `failedItems.error.refId` (string)
    The ID of the specific error occurrence. Please include this information when contacting Smartsheet support.

  - `failedItems.error.errorCode` (number)
    Custom error code from Smartsheet. See the complete [Error Code List](/api/smartsheet/error-codes).

  - `failedItems.error.message` (string)
    Descriptive error message.

  - `failedItems.index` (number)
    The index of the failed item in the bulk request array.

  - `message` (string)
    Message that indicates the outcome of the request. (One of SUCCESS or PARTIAL_SUCCESS.)
    Enum: "PARTIAL_SUCCESS", "SUCCESS"

  - `resultCode` (number)
    * '0' Success
* '3' Partial Success of Bulk Operation
    Enum: 0, 3

  - `result` (object)

  - `result.endColumnId` (number)
    Defines ending edge of range when specifying one or more columns. To specify an entire column, omit the startRowId and endRowId parameters.

  - `result.endRowId` (number)
    Defines ending edge of range when specifying one or more rows. To specify an entire row, omit the startColumnId and endColumnId parameters.

  - `result.id` (number)
    Cross-sheet reference ID, guaranteed unique within referencing sheet.

  - `result.name` (string)
    Friendly name of reference. Auto-generated unless specified in Create Cross-sheet References.

  - `result.startColumnId` (number)
    Defines beginning edge of range when specifying one or more columns. To specify an entire column, omit the startRowId and endRowId parameters.

  - `result.startRowId` (number)
    Defines beginning edge of range when specifying one or more rows. To specify an entire row, omit the startColumnId and endColumnId parameters.

  - `result.status` (string)
    Status of request:
 * 'BLOCKED' - A reference is downstream of a circular issue.
 * 'BROKEN' - The data source location (column, row or sheet) was deleted.
 * 'CIRCULAR' - The formula reference is self referencing and cannot be resolved.
 * 'DISABLED' - Updating the reference is temporarily disabled due to maintenance.
 * 'INVALID/UNKNOWN' - The reference is new and had not been validated.
 * 'NOT_SHARED' - No common shared users.
 * 'OK' - The reference is in a good state.
    Enum: "BLOCKED", "BROKEN", "CIRCULAR", "DISABLED", "INVALID/UNKNOWN", "NOT-SHARED", "OK"

  - `result.sourceSheetId` (number)
    Sheet ID of source sheet.

## Response default fields (application/json):

  - `refId` (string)
    The ID of the specific error occurrence. Please include this information when contacting Smartsheet support.

  - `errorCode` (number)
    Custom error code from Smartsheet. See the complete [Error Code List](/api/smartsheet/error-codes).

  - `message` (string)
    Descriptive error message.


